#ifndef MYSTRING_H_
#define MYSTRING_H_

#include <iostream>
#include <string.h>


class MyString {
public:
	MyString(const char *value)
	{
	  if (value) {
		data = new char[strlen(value) + 1];
		strcpy(data, value);
	  }
	  else {
		data = new char[1];
		*data = '\0';
	  }
	}

	~MyString() { delete [] data; }

	//Implementation fuer cctor und ass
	MyString(const MyString& s) {
		//copy data from s to myself
	  if (s.data) {
		data = new char[strlen(s.data) + 1];
		strcpy(data, s.data);
	  }
	  else {
		data = new char[1];
		*data = '\0';
	  }

	}
	MyString& operator=(const MyString& rhs) {
		// delete mydata first
		// copy data from s to myself
	 delete [] data;

	  if (rhs.data) {
		data = new char[strlen(rhs.data) + 1];
		strcpy(data, rhs.data);
	  }
	  else {
		data = new char[1];
		*data = '\0';
	  }

	  return *this;
	}

	const char* getData() { return data; }
	void printData() { std::cout << data << std::endl; }
private:
	char* data;

	//prevent copying and assignment, EC++ Item 11
//	MyString(const MyString& s);				//declared private do NOT define it
//	MyString& operator=(const MyString& rhs);   //declared private do NOT define it
};


#endif /* MYSTRING_H_ */
